﻿//PROXIMA DIA: poner parametros en funciones de interval y probar mucho, hacer cola para animaciones bien hecha.

//Incluye las clases necesarias:
import as.Registro;

//Clase para el ranking:
class as.Ranking
{
	//Propiedades modificables:
	static var numeroRegistrosMaximo : Number = 20; //Numero de registros para el ranking (se actualiza automaticamente, pero nunca supera al maximo).
	static var archivoRanking : String = "http://surfweb.dyndns.org:8885/ranking/ranking.cfm"; //"http://surfweb.dyndns.org:8885/ranking/ranking.php?clave=123"; //http://w2003vm/ranking/ranking.php?clave=123"; //datos/ranking.txt"; //Archivo de donde leer los registros.

	var milisegundosCiclo : Number = 2500; //Milisegundos que tarda en volver a leer el ranking, al iniciar el ciclo.
	static var milisegundosCicloAparecer : Number = 10; //Milisegundos que tarda en volver a hacer el ciclo de aparecer.
	static var milisegundosCicloDeslizar : Number = 2; //Milisegundos que tarda en volver a hacer el ciclo de deslizar.
	static var milisegundosCicloIntercambiar : Number = 5; //Milisegundos que tarda en volver a hacer el ciclo de intercambiar.
	static var milisegundosCicloActualizar : Number = 10; //Milisegundos que tarda en volver a hacer el ciclo de actualizar.
	static var milisegundosDuracionFlecha : Number = 10000; //Milisegundos que tarda la flecha en desaparecer (-1 = siempre visible, 0 = nunca visisble).
	
	static var espacioEntreRegistros : Number = 20; //Numero de pixels entre un registro y otro (ojo: entre sus top).
	static var rankingTop : Number = 2; //Posicion vertical, en pixels, del ranking.
	static var rankingLeft : Number = 270; //Posicion horizontal, en pixels, del ranking.
	static var anchoRegistro : Number = 260; //Ancho en pixels de cada registro.
	static var anchoRegistroMaximo : Number = 640; //Ancho maximo en pixels de cada registro (el tope que puede tomar en una animacion).
	static var altoRegistro : Number = 25; //Alto en pixels de cada registro.
	static var margenRegistro : Number = 10; //Margen en pixels de cada registro.
	
	static var usarColaAnimaciones : Boolean = false; //Define si utilizar una cola para las animaciones, para que no se ejecuten a la vez.
	
	//Propiedades no modificables:
	static var numeroRegistros : Number = Ranking.numeroRegistros; //Numero de registros para el ranking (se actualiza automaticamente, pero nunca supera al maximo).

	var intervalCiclo : Number = null; //Variable que guarda el interval para hacer el ciclo (si, es numerica).
	
	static var movieClip : MovieClip = null; //Guarda el MovieClip donde se representa el ranking.

	static var registros : Array = new Array(); //Guarda los registros del ranking.
	
	static var registrosClips : Array = new Array(); //Guarda los clips de pelicula de cada posicion del ranking.

	static var alphaAparecer : Array = new Array(); //Alpha que utiliza la animacion de aparecer, para cada posicion del ranking.
	static var intervalAparecer : Array = new Array(); //Interval de la animacion de aparecer, para cada posicion del ranking.

	static var topDeslizar : Array = new Array(); //Alto que utiliza la animacion de deslizar, para cada posicion del ranking.
	static var anchoDeslizar : Array = new Array(); //Ancho que utiliza la animacion de deslizar, para cada posicion del ranking.
	static var intervalDeslizar : Array = new Array(); //Interval de la animacion de deslizar, para cada posicion del ranking.

	static var topIntercambiar : Array = new Array(); //Alto que utiliza la animacion de intercambiar, para cada posicion del ranking.
	static var leftIntercambiar : Array = new Array(); //Left que utiliza la animacion de intercambiar, para cada posicion del ranking.
	static var anchoIntercambiar : Array = new Array(); //Ancho que utiliza la animacion de intercambiar, para cada posicion del ranking.
	static var intervalColaAnimaciones : Array = new Array(); //Interval para la cola de animaciones, para cada posicion del ranking (el indice es el id).
	static var intervalIntercambiar : Array = new Array(); //Interval de la animacion de intercambiar, para cada posicion del ranking.
	static var intervalActualizar : Array = new Array(); //Interval de la animacion de actualizar, para cada posicion del ranking (el indice es el id).
	static var intervalFlechaDesaparecer : Array = new Array(); //Interval de desaparecer la flecha, para cada posicion del ranking (el indice es el id).
	
	static var enAnimacion : Array = new Array();
	
	
	function Ranking(movieClip : MovieClip)
	{
		//Define el MovieClip necesario para representar el ranking:
		Ranking.setMovieClip(movieClip);
		//Carga los valores del ranking por primera vez:
		this.cargarRegistros();
	}

	static function setMovieClip(movieClip : MovieClip)
	{
		Ranking.movieClip = movieClip;
	}
	
	static function getMovieClip()
	{
		return Ranking.movieClip;
	}
	
	static function setNumeroRegistros(numeroRegistros : Number) : Void
	{
		Ranking.numeroRegistros = numeroRegistros;
	}
	
	static function getNumeroRegistros() : Number
	{
		return Ranking.numeroRegistros;
	}

	static function setNumeroRegistrosMaximo(numeroRegistrosMaximo : Number) : Void
	{
		Ranking.numeroRegistrosMaximo = numeroRegistrosMaximo;
	}
	
	static function getNumeroRegistrosMaximo() : Number
	{
		return Ranking.numeroRegistrosMaximo;
	}
	
	static function setRegistros(registros : Array) : Void
	{
		Ranking.registros = registros;
	}
	
	static function getRegistros() : Array
	{
		var registros : Array = new Array();
		for (var x = 0; x < Ranking.registros.length; x++)
		{
			registros[x] = Ranking.registros[x];
		}
		return registros;
	}
	
	static function setRegistro(registro : Registro, posicion : Number) : Void
	{
		Ranking.registros[posicion] = registro;
	}
	
	static function getRegistro(posicion : Number)
	{
		var registro : Registro = null;
		if (posicion < Ranking.registros.length)
		{
			registro = Ranking.registros[posicion];
		}
		return registro;
	}
	
	static function intercambiarRegistros(registro1 : Registro, posicion1 : Number, registro2 : Registro, posicion2 : Number) : Void
	{
		var temp : Registro = registro1;
		Ranking.setRegistro(registro2, posicion1);
		Ranking.setRegistro(temp, posicion2);
	}
	
	static function setArchivoRanking(archivoRanking : String) : Void
	{
		Ranking.archivoRanking = archivoRanking;
	}
	
	static function getArchivoRanking() : String
	{
		return Ranking.archivoRanking;
	}
	
	function setMilisegundosCiclo(milisegundosCiclo : Number) : Void
	{
		this.milisegundosCiclo = milisegundosCiclo;
	}
	
	function getMilisegundosCiclo() : Number
	{
		return this.milisegundosCiclo;
	}
	
	static function setEspacioEntreRegistros(espacioEntreRegistros : Number) : Void
	{
		Ranking.espacioEntreRegistros = espacioEntreRegistros;
	}
	
	static function getEspacioEntreRegistros() : Number
	{
		return Ranking.espacioEntreRegistros;
	}
	
	static function setRankingLeft(rankingLeft : Number) : Void
	{
		Ranking.rankingLeft = rankingLeft;
	}
	
	static function getRankingLeft() : Number
	{
		return Ranking.rankingLeft;
	}

	static function setRankingTop(rankingTop : Number) : Void
	{
		Ranking.rankingTop = rankingTop;
	}
	
	static function getRankingTop() : Number
	{
		return Ranking.rankingTop;
	}
	
	static function setAnchoRegistro(anchoRegistro : Number) : Void
	{
		Ranking.anchoRegistro = anchoRegistro;
	}

	static function getAnchoRegistro() : Number
	{
		return Ranking.anchoRegistro;
	}

	static function setAnchoRegistroMaximo(anchoRegistroMaximo : Number) : Void
	{
		Ranking.anchoRegistroMaximo = anchoRegistroMaximo;
	}

	static function getAnchoRegistroMaximo() : Number
	{
		return Ranking.anchoRegistroMaximo;
	}
	
	static function setAltoRegistro(altoRegistro : Number) : Void
	{
		Ranking.altoRegistro = altoRegistro;
	}

	static function getAltoRegistro() : Number
	{
		return Ranking.altoRegistro;
	}
	
	static function setMargenRegistro(margenRegistro : Number) : Void
	{
		Ranking.margenRegistro = margenRegistro;
	}

	static function getMargenRegistro() : Number
	{
		return Ranking.margenRegistro;
	}
	
	static function setUsarColaAnimaciones(usarColaAnimaciones : Boolean) : Void
	{
		Ranking.usarColaAnimaciones = usarColaAnimaciones;
	}
	
	static function getUsarColaAnimaciones() : Boolean
	{
		return Ranking.usarColaAnimaciones;
	}
	
	//Almacena el clip de pelicula de un registro:
	static function setClipRegistro(movieClip : MovieClip, ID : Number) : Void
	{
		Ranking.registrosClips[ID] = movieClip;
	}
	
	//Devuelve el clip de pelicula de un registro:
	static function getClipRegistro(ID : Number) : MovieClip
	{
		var movieClip : MovieClip = null;
		
		movieClip = Ranking.registrosClips[ID];
		
		return movieClip;
	}
	
	//Inicia el ciclo de carga del ranking:
	function iniciarCiclo() : Void
	{
		//Si no esta comenzado, lo comienza:
		if (this.intervalCiclo == null)
		{
			this.intervalCiclo = setInterval(this.cargarRegistros, this.getMilisegundosCiclo());
		}
	}
	
	//Termia el ciclo de carga del ranking:
	function pararCiclo() : Void
	{
		clearInterval(this.intervalCiclo);
		this.intervalCiclo = null;
	}
	
	//Borra los espacios al principio y al final de una cadena, y la retorna:
	static function trim(cadena : String) : String
	{
		//Quita los espacios de la izquierda:
		while (cadena.substring(0, 1) == " ")
		{
			cadena = cadena.substring(1, cadena.length);
		}
		
		//Quita los espacios de la derecha:
		while (cadena.substring(cadena.length - 1, cadena.length) == " ")
		{
			cadena = cadena.substring(0, cadena.length - 1)
		}

		return cadena;
	}
	
	//Reordena un vector de registros por su valor, de mayor a menor:
	static function ordenarPorValor(registros : Array) : Array //Metodo de la burbuja.
	{
		var temp : Registro;
		
		for (var x = registros.length - 1; x > 0; x--)
		{
			for (var y = 0; y < x; y++)
			{
				if (registros[y].getValor() < registros[y + 1].getValor())
				{
					temp = registros[y + 1];
					registros[y + 1] = registros[y];
					registros[y] = temp;
				}
			}
		}

		return registros;
	}
	
	//Devuelve la posicion de un registro dentro de un vector de regitros:
	static function calcularPosicion(registro : Registro, registros : Array) : Number
	{
		var posicion : Number = -1;
		
		var id : Number = registro.getID();
		
		for (var x = 0; x < registros.length; x++)
		{
			if (id == registros[x].getID())
			{
				posicion = x;
				break;
			}
		}
		
		return posicion;
	}
	
	//Purga (elimina) todos los clips que ya no existen en el ranking dado:
	static function purgarClips(registros : Array)
	{
		//Recorre los registros del ranking actual:
		var registro : Registro;
		for (var x = 0; x < Ranking.registros.length; x++)
		{
			registro = Ranking.registros[x];
			//Si habia un registro y ya no esta en el ranking dado o supera su dimension, lo hace desaparecer:
			if (registro != null && (Ranking.calcularPosicion(registro, registros) == -1 || Ranking.calcularPosicion(registro, registros) >= Ranking.getNumeroRegistrosMaximo()))
			{
				var clipRegistro : MovieClip = Ranking.getClipRegistro(registro.getID());
				clipRegistro.removeMovieClip();
				Ranking.setClipRegistro(null, registro.getID());
			}
		}
	}
	
	//Devuelve si hay animaciones en curso o no:
	static function hayAnimaciones() : Boolean
	{
		var existen = false;

		for (var indice : String in Ranking.enAnimacion)
		{
			if (Ranking.enAnimacion[indice]) { existen = true; break; }
		}
		
		return existen;
	}
	
	//Borra la cola de animaciones (los interval):
	static function borrarColaAnimaciones() : Boolean
	{
		var existen = false;

		for (var indice : String in Ranking.intervalColaAnimaciones)
		{
			if (Ranking.intervalColaAnimaciones[indice] != null)
			{
				clearInterval(Ranking.intervalColaAnimaciones[indice]);
			}
		}
		
		return existen;
	}
	
	//Carga los registros desde el archivo del ranking:
	function cargarRegistros() : Void
	{
		//Lee el archivo y lo carga en un vector (cogido de http://miprogramacionenjuegos.wordpress.com/2006/12/21/la-clase-loadvars-para-leer-datos-de-archivos-txt/):
		var archivoCargado = new LoadVars();
		
		//Funcion a ejecutar cuando el archivo termine de cargarse:
		archivoCargado.onLoad = function(todoBien)
  					   		    {
									//Si se ha cargado correctamente el archivo:
									if (todoBien)
									{
										//Si hay una animacion activa, sale:
										if (Ranking.hayAnimaciones()) { return; }
										
										//Si se utiliza cola para las animaciones, interrumpe las que pudieran haber en ella:
										//if (Ranking.getUsarColaAnimaciones()) { Ranking.borrarColaAnimaciones(); }
										
										//Guarda los registros anteriores:
										var registrosAnteriores : Array = Ranking.getRegistros();

										//Guarda el texto del archivo en una variable:
										var texto : String = unescape(archivoCargado.toString());
										
										//Quita la cadena que por defecto pone el Flash (Macromedia Flash Professional 8):
										if (texto.indexOf("&onLoad=[type Function]", 0) != -1) { texto = texto.substring(0, texto.indexOf("&onLoad=[type Function]", 0)); }
										
										//Crea un vector con todos los registros:
										var filas : Array = texto.split(";");
										
										//Guarda los registros nuevos:
										var registrosNuevos : Array = new Array();//Ranking.getNumeroRegistros());
										var columnas : Array = new Array();
										var columnaNombreValor : Array = new Array();
										var columnasValor : Array = new Array();
										var id : Number;
										var nombre : String;
										var valor : Number;
										var registro : Registro;
										var actualizarRegistroActual : Boolean = false;
										for (var x = 0; x < filas.length; x++) //Desglosa cada registro en los valores de sus columnas.
										{
											//Desglosa la fila actual en sus columnas:
											columnas = filas[x].split(":");
											
											//Si no hay las columnas suficientes, salta este loop:
											if (columnas.length < 3) { continue; }
											
											//Recorre las columnas y recoge su valor, quitandoles espacios innecesarios:
											for (var y = 0; y < columnas.length; y++)
											{
												columnaNombreValor = columnas[y].split("=");
												if (columnaNombreValor.length >= 2)
												{
													columnasValor[y] = Ranking.trim(columnaNombreValor[1]);
												}
											}

											id = parseFloat(columnasValor[0]);
											nombre = columnasValor[1];
											valor = parseFloat(columnasValor[2]);
											
											//Guarda el nuevo registro:
											registro = new Registro(id, nombre, valor);
											registrosNuevos[x] = registro;
										}
										
										//Ordena los registros antiguos y nuevos por su valor, de mayor a menor:
										registrosAnteriores = Ranking.ordenarPorValor(registrosAnteriores);
										registrosNuevos = Ranking.ordenarPorValor(registrosNuevos);
										
										//Pone el numero de registros nuevo (por si cambiara):
										var registrosPuestos : Number = x - 1;
										Ranking.setNumeroRegistros(registrosPuestos);
										
										//Recorre los nuevos registros y si han cambiado, los mueve:
										var posicionAnterior : Number;
										var temp : Registro;
										for (x = 0; x < registrosPuestos; x++)
										{
											//Calcula la posicion anterior donde estaba el registro:
											actualizarRegistroActual = false;
											posicionAnterior = Ranking.calcularPosicion(registrosNuevos[x], registrosAnteriores); //Calcula donde estaba antes el registro nuevo.
											
											//Si el registro no existia antes, lo hace aparecer:
											if (posicionAnterior < 0)
											{
												Ranking.aparecerRegistro(registrosNuevos[x], x, registrosNuevos);
											}
											//...pero si ya existia:
											else
											{
												//Si la duracion de la flecha es -1 (siempre visible), vuelve a poner la accion que tenia al registro:
												if (Ranking.milisegundosDuracionFlecha == -1) { registrosNuevos[x].setAccion(Ranking.registros[posicionAnterior].getAccion()); }

												//Si esta en otra posicion diferente, mueve el registro:
												if (x != posicionAnterior)
												{
													
													//Si se ha de utilizar cola, hace una pausa hasta que acaben todas las animaciones:
													/*
													if (Ranking.getUsarColaAnimaciones())
													{
														trace("* Inicia bucle de espera...");
														while (Ranking.hayAnimaciones()) {  }
														//if (Ranking.hayAnimaciones())
														{
															//trace("Hay animaciones!!!!!!!!!!!!!!!!!!!!!!!");
														}
														//else { trace("NO HAY ANIMACIONESSSSSSSSSSSsssssssssss"); }
														trace("* Finaliza bucle de espera.");
													}
													*/
													
													
													//Si se ha definido utilizar una cola en las animaciones, se hace:
													if (Ranking.getUsarColaAnimaciones())
													{
														var posicionPosterior = x;
														var registroCola = registrosNuevos[posicionPosterior];
														var idRegistro = registroCola.getID();
														
														//Ranking.enAnimacion[idRegistro + ""] = true;
														
														clearInterval(Ranking.intervalColaAnimaciones[idRegistro]);
														
														trace("*** Comienza la cola para "+idRegistro+":");
														Ranking.intervalColaAnimaciones[idRegistro] = setInterval(
																									  function(x : Number, registrosNuevos : Array)
																									  {
																										var posicionPosterior = x;
																										var registroCola = registrosNuevos[posicionPosterior];
																										var idRegistro = registroCola.getID();

																										if (!Ranking.hayAnimaciones())
																										{
																											//Ranking.enAnimacion[idRegistro + ""] = false;

																											Ranking.moverRegistro(registroCola, posicionAnterior, posicionPosterior, registrosNuevos);
																											clearInterval(Ranking.intervalColaAnimaciones[idRegistro]);
																											trace("* Interval de animacion para "+idRegistro+" efectuado!");
																										}
																										else { trace("* Interval de animacion esperando para "+idRegistro+"..."); }
																									  }
											   														  , 1000, x, registrosNuevos);
																									  //, 1000, idRegistro, registroCola, posicionAnterior, posicionPosterior, registrosNuevos);
													}
													
													//...si no, se ejecuta sin esperar:
													else
													{
														Ranking.moverRegistro(registrosNuevos[x], posicionAnterior, x, registrosNuevos);
													}
												}
												//...si no, si esta en la misma posicion solo lo actualizara:
												else
												{
													actualizarRegistroActual = true;
												}
											}
											
											//Si se ha definido actualizar el registro, lo hace:
											if (actualizarRegistroActual)
											{
												//Si va a estar en una posicion que no aparece en el ranking, sale:
												if (x >= Ranking.getNumeroRegistrosMaximo()) { continue; }
												
												var clipRegistro : MovieClip = Ranking.getClipRegistro(registrosNuevos[x].getID());
												
												//Si aun no existe, lo carga:
												if (clipRegistro == null)
												{
													clipRegistro = movieClip.attachMovie("ClipRegistro", "clipRegistro_" + registrosNuevos[x].getID(), movieClip.getNextHighestDepth());
													Ranking.setClipRegistro(clipRegistro, registrosNuevos[x].getID());
												}
												
												//Actualiza el registro:
												Ranking.actualizarRegistro(clipRegistro, registrosNuevos[x], x);
											}
										}
										
										//Define el nuevo ranking:
										Ranking.setRegistros(registrosNuevos);
									}
							    };
								
		archivoCargado.load(Ranking.getArchivoRanking());
	}
	
	//Hace aparecer un registro en una posicion indicada:
	static function aparecerRegistro(registro : Registro, posicion : Number, registrosNuevos : Array) : Void
	{
		//Si quedan clips que ya no existen, los hace desaparecer:
		Ranking.purgarClips(registrosNuevos);
		
		//Si va a estar en una posicion que no aparece en el ranking, sale:
		if (posicion >= Ranking.getNumeroRegistrosMaximo()) { return; }
		
		//Almacena el registro que habia anteriormente:
		var registroAnterior : Registro = Ranking.getRegistro(posicion);

		//Pone la accion del registro segun sea la primera vez que aparece el ranking o no:
		if (registroAnterior == null) //La primera vez que se representa el ranking.
		{
			Ranking.ponerFlecha(registro, "igual");
			//registro.setAccion(1); //Igual.
		}
		else //Ya no es la primera vez que se representa el ranking.
		{
			Ranking.ponerFlecha(registro, "sube");
			//registro.setAccion(2); //Sube.
		}
		
		//Representa la animacion de aparecer el registro:
		Ranking.representarAnimacionAparecer(registro, posicion, registroAnterior, registrosNuevos);
		
		//Inserta el registro en el ranking, de forma interna:
		Ranking.setRegistro(registro, posicion);
	}
	
	//Mueve un registro del ranking a una posicion indicada:
	static function moverRegistro(registro : Registro, posicionAnterior : Number, posicionPosterior : Number, registrosNuevos : Array) : Void
	{
		//Si quedan clips que ya no existen, los hace desaparecer:
		Ranking.purgarClips(registrosNuevos);

		//Si va a estar en una posicion que no aparece en el ranking, sale:
		if (posicionPosterior >= Ranking.getNumeroRegistrosMaximo()) { return; }
		
		//Pone la accion del registro segun haya subido o bajado:
		if (posicionAnterior < posicionPosterior)
		{
			//registro.setAccion(0); //Baja.
			Ranking.ponerFlecha(registro, "baja");
		}
		else if (posicionAnterior > posicionPosterior)
		{
			//registro.setAccion(2); //Sube.
			Ranking.ponerFlecha(registro, "sube");
		}
		else
		{
			//registro.setAccion(4); //Nada.
			Ranking.ponerFlecha(registro, "nada");
		}
		
		//Si el registro va a estar en la misma posicion, sale:
		if (posicionAnterior == posicionPosterior)
		{
			return;
		}
		//...pero si las posiciones estan consecutivas, ejecuta una animacion de "deslizamiento":
		else if (Math.abs(posicionAnterior - posicionPosterior) == 1)
		{
			Ranking.representarAnimacionDeslizar(registro, posicionAnterior, posicionPosterior, registrosNuevos);
		}
		//...pero si no, ejecuta una animacion de "salto":
		else
		{
			Ranking.representarAnimacionIntercambiar(registro, posicionAnterior, posicionPosterior, registrosNuevos);
		}
		
		//Pone el registro en su nueva posicion, de forma interna:
		Ranking.setRegistro(registro, posicionPosterior);
	}

	//Actualiza un registro:
	static function actualizarRegistro(clipRegistro : MovieClip, registro : Registro, posicion : Number) : Void
	{
		//Va al fotograma conveniente del clip del registro, segun su accion:
		//clipRegistro.gotoAndStop(registro.getAccion() + 1);
		
		//Define el texto del clip del registro:
		clipRegistro.texto.text = registro.getNombre();
		
		//Define el numero y valor del clip del registro (haciendo una animacion):		
		Ranking.representarAnimacionActualizar(registro.getID(), clipRegistro, clipRegistro.numero.text, posicion + 1, clipRegistro.valor.text, registro.getValor());
	}
	
	//Reproduce la animacion de aparecer un registro nuevo en una posicion:
	static function representarAnimacionAparecer(registro : Registro, posicion : Number, registroAnterior : Registro, registrosNuevos : Array) : Void
	{
		var movieClip : MovieClip = Ranking.getMovieClip();
		if (movieClip == null) { return; }
		
		var margenRegistro : Number = Ranking.getMargenRegistro();
		
		var clipRegistro : MovieClip = Ranking.getClipRegistro(registro.getID());
		
		//Si aun no existe, lo carga:
		if (clipRegistro == null)
		{
			clipRegistro = movieClip.attachMovie("ClipRegistro", "clipRegistro_" + registro.getID(), movieClip.getNextHighestDepth());
			Ranking.setClipRegistro(clipRegistro, registro.getID());
		}
		
		//Define el texto, numero y valor del clip del registro:
		clipRegistro.texto.text = registro.getNombre();
		clipRegistro.numero.text = posicion + 1;
		clipRegistro.valor.text = registro.getValor();

		//Va al fotograma conveniente del clip del registro, segun su accion:
		//clipRegistro.gotoAndStop(registro.getAccion() + 1);
		
		//Posiciona correctamente el clip del registro:
		var left : Number = Ranking.getRankingLeft();
		var top : Number = (Ranking.getEspacioEntreRegistros() + margenRegistro) * (posicion) + Ranking.getRankingTop();
		clipRegistro._x = left;
		clipRegistro._y = top;

		//Modifica la dimension del clip del registro:
		clipRegistro._width = Ranking.getAnchoRegistro();
		clipRegistro._height = Ranking.getAltoRegistro();
		
		//Se restaura el alpha, por si acaso:
		//clipRegistro._alpha = 100;
		//clipRegistro.texto._alpha = 0;
		
		//Crea la animacion:
		var id : Number = registro.getID();
		Ranking.enAnimacion[id + ""] = true;
		Ranking.alphaAparecer[posicion] = 0;
		Ranking.intervalAparecer[posicion] = setInterval(
											 function()
  											 {
											 	var alpha : Number = Ranking.alphaAparecer[posicion]++;
												clipRegistro._alpha = alpha;
												if (alpha >= 100)
												{
													clearInterval(Ranking.intervalAparecer[posicion]);
													clipRegistro._alpha = 100;
													Ranking.enAnimacion[id + ""] = false;
												}
											 }
											 , Ranking.milisegundosCicloAparecer, posicion, clipRegistro, id);
	}
	
	//Reproduce la animacion de mover un una posicion en el ranking a un lugar consecutivo (realiza un "deslizamiento"):
	static function representarAnimacionDeslizar(registro : Registro, posicionAnterior : Number, posicionPosterior : Number, registrosNuevos : Array) : Void
	{
		var movieClip : MovieClip = Ranking.getMovieClip();
		if (movieClip == null) { return; }
		
		var margenRegistro : Number = Ranking.getMargenRegistro();

		var clipRegistro : MovieClip = Ranking.getClipRegistro(registro.getID());
		
		//Si aun no existe, lo carga:
		if (clipRegistro == null)
		{
			clipRegistro = movieClip.attachMovie("ClipRegistro", "clipRegistro_" + registro.getID(), movieClip.getNextHighestDepth());
			Ranking.setClipRegistro(clipRegistro, registro.getID());
		}
		
		//Define el texto, numero y valor del clip del registro:
		clipRegistro.texto.text = registro.getNombre();
		Ranking.representarAnimacionActualizar(registro.getID(), clipRegistro, clipRegistro.numero.text, posicionPosterior + 1, clipRegistro.valor.text, registro.getValor());

		//Va al fotograma conveniente del clip del registro, segun su accion:
		//clipRegistro.gotoAndStop(registro.getAccion() + 1);
		
		//Posiciona correctamente el clip del registro:
		var left : Number = Ranking.getRankingLeft();
		var top : Number = (Ranking.getEspacioEntreRegistros() + margenRegistro) * (posicionAnterior) + Ranking.getRankingTop();
		clipRegistro._x = left;
		clipRegistro._y = top;

		//Modifica la dimension del clip del registro:
		clipRegistro._width = Ranking.getAnchoRegistro();
		clipRegistro._height = Ranking.getAltoRegistro();

		//Se restaura el alpha, por si acaso:
		//clipRegistro._alpha = 100;
		//clipRegistro.texto._alpha = 0;
		
		//Crea la animacion:
		var id : Number = registro.getID();
		Ranking.enAnimacion[id + ""] = true;
		Ranking.topDeslizar[posicionAnterior] = top;
		Ranking.anchoDeslizar[posicionAnterior] = Ranking.getAnchoRegistro();
		var topInicial : Number = top;
		Ranking.intervalDeslizar[posicionAnterior] = setInterval(
													 function()
  											 		 {
														var margenRegistro : Number = Ranking.getMargenRegistro();
														var top : Number = Ranking.topDeslizar[posicionAnterior];
														var topDestino = (Ranking.getEspacioEntreRegistros() + margenRegistro) * (posicionPosterior) + Ranking.getRankingTop();
														
														var ancho : Number = Ranking.anchoDeslizar[posicionAnterior];
														
														if (Math.abs(top - topDestino) >= Math.abs(topInicial - topDestino) / 2) { Ranking.anchoDeslizar[posicionAnterior]--; }
														else { Ranking.anchoDeslizar[posicionAnterior]++; }
		
														if (posicionAnterior < posicionPosterior) { Ranking.topDeslizar[posicionAnterior]++; }
														else { Ranking.topDeslizar[posicionAnterior]--; }
														
														clipRegistro._y = top;
														clipRegistro._width = ancho;
														
														if (posicionAnterior < posicionPosterior && top >= topDestino
															|| posicionAnterior > posicionPosterior && top <= topDestino)
														{
															clearInterval(Ranking.intervalDeslizar[posicionAnterior]);
															clipRegistro._width = Ranking.getAnchoRegistro();
															Ranking.enAnimacion[id + ""] = false;
														}
													  }
													  , Ranking.milisegundosCicloDeslizar, posicionAnterior, posicionPosterior, clipRegistro, top, id);
	}
	
	//Reproduce la animacion de mover una posicion en el ranking a un lugar no consecutivo (realiza un "salto"):
	static function representarAnimacionIntercambiar(registro : Registro, posicionAnterior : Number, posicionPosterior : Number, registrosNuevos : Array) : Void
	{
		var movieClip : MovieClip = Ranking.getMovieClip();
		if (movieClip == null) { return; }
		
		var margenRegistro : Number = Ranking.getMargenRegistro();

		var clipRegistro : MovieClip = Ranking.getClipRegistro(registro.getID());
		
		//Si aun no existe, lo carga:
		if (clipRegistro == null)
		{
			clipRegistro = movieClip.attachMovie("ClipRegistro", "clipRegistro_" + registro.getID(), movieClip.getNextHighestDepth());
			Ranking.setClipRegistro(clipRegistro, registro.getID());
		}
		
		//Define el texto, numero y valor del clip del registro:
		clipRegistro.texto.text = registro.getNombre();
		Ranking.representarAnimacionActualizar(registro.getID(), clipRegistro, clipRegistro.numero.text, posicionPosterior + 1, clipRegistro.valor.text, registro.getValor());
		
		//Va al fotograma conveniente del clip del registro, segun su accion:
		//clipRegistro.gotoAndStop(registro.getAccion() + 1);
		
		//Posiciona correctamente el clip del registro:
		var left : Number = Ranking.getRankingLeft();
		var top : Number = (Ranking.getEspacioEntreRegistros() + margenRegistro) * (posicionAnterior) + Ranking.getRankingTop();
		clipRegistro._x = left;
		clipRegistro._y = top;

		//Modifica la dimension del clip del registro:
		clipRegistro._width = Ranking.getAnchoRegistro();
		clipRegistro._height = Ranking.getAltoRegistro();

		//Se restaura el alpha, por si acaso:
		//clipRegistro._alpha = 100;
		//clipRegistro.texto._alpha = 0;
		
		//Pone el clip encima de todo:
		clipRegistro.swapDepths(1000);
		
		//Crea la animacion:
		var id : Number = registro.getID();
		Ranking.enAnimacion[id + ""] = true;
		Ranking.topIntercambiar[posicionAnterior] = top;
		Ranking.leftIntercambiar[posicionAnterior] = left;
		Ranking.anchoIntercambiar[posicionAnterior] = Ranking.getAnchoRegistro();
		var topInicial : Number = top;
		Ranking.intervalIntercambiar[posicionAnterior] = setInterval(
														 function()
  											 			 {
															var margenRegistro : Number = Ranking.getMargenRegistro();
															var top : Number = Ranking.topIntercambiar[posicionAnterior];
															var topDestino = (Ranking.getEspacioEntreRegistros() + margenRegistro) * (posicionPosterior) + Ranking.getRankingTop();
															
															var left : Number = Ranking.leftIntercambiar[posicionAnterior];
															
															var ancho : Number = Ranking.anchoIntercambiar[posicionAnterior];

															//Si el camino por recorrer es interior al doble del alto de dos registros:
															if (Math.abs(top - topDestino) <= Ranking.getAltoRegistro() * 2)
															{
																//Si aun se puede decrementar el ancho del registro, se incrementa su left:
																if (Ranking.anchoIntercambiar[posicionAnterior] - 2 >= Ranking.getAnchoRegistro())
																{
																	Ranking.leftIntercambiar[posicionAnterior]++;
																	Ranking.anchoIntercambiar[posicionAnterior] -= 2;
																}
																//...si no, se pone el ancho al minimo permitido y se mantiene el left:
																else
																{
																	Ranking.anchoIntercambiar[posicionAnterior] = Ranking.getAnchoRegistro();
																}
															}
															//...pero si no (el camino por recorrer es superior o igual a la mitad):
															else if (Math.abs(top - topDestino) >= Math.abs(topInicial - topDestino) / 2)
															{
																//Si aun se puede incrementar el ancho del registro, se decrementa su left:
																if (Ranking.anchoIntercambiar[posicionAnterior] + 2 <= Ranking.getAnchoRegistroMaximo())
																{
																	Ranking.leftIntercambiar[posicionAnterior]--;
																	Ranking.anchoIntercambiar[posicionAnterior] += 2;
																}
																//...si no, se pone el ancho al maximo permitido y se mantiene el left:
																else
																{
																	Ranking.anchoIntercambiar[posicionAnterior] = Ranking.getAnchoRegistroMaximo();
																}
															}
			
															if (posicionAnterior < posicionPosterior) { Ranking.topIntercambiar[posicionAnterior]++; }
															else { Ranking.topIntercambiar[posicionAnterior]--; }
															
															clipRegistro._y = top;
															clipRegistro._x = left;

															clipRegistro._width = ancho;
															
															if (posicionAnterior < posicionPosterior && top >= topDestino
																|| posicionAnterior > posicionPosterior && top <= topDestino)
															{
																clearInterval(Ranking.intervalIntercambiar[posicionAnterior]);
																clipRegistro._width = Ranking.getAnchoRegistro();
																clipRegistro._x = Ranking.getRankingLeft();
																clipRegistro.swapDepths(1);
																Ranking.enAnimacion[id + ""] = false;
															}
														  }
														  , Ranking.milisegundosCicloIntercambiar, posicionAnterior, posicionPosterior, clipRegistro, top, topInicial, id);
	}
	
	//Representa la animacion de actualizar un registro:
	static function representarAnimacionActualizar(idRegistro : Number, clipRegistro : MovieClip, posicionAnterior : Number, posicionPosterior : Number, valorAnterior : Number, valorPosterior : Number) : Void
	{
		clearInterval(Ranking.intervalActualizar[idRegistro]);
		Ranking.enAnimacion[idRegistro + ""] = true;
		Ranking.intervalActualizar[idRegistro] = setInterval(
												 function()
		  										 {
													var posicionTemporal : Number = parseInt(clipRegistro.numero.text);
													var valorTemporal : Number =  parseFloat(clipRegistro.valor.text);
													
													//Va actualizando la posicion del ranking:
													if (posicionTemporal < posicionPosterior)
													{
														posicionTemporal++;
													}
													else if (posicionTemporal > posicionPosterior)
													{
														posicionTemporal--;
													}
													
													//Va actualizando el valor (en intervalos grandes si se puede):
													if (valorTemporal < valorPosterior)
													{
														//Elige un incremento lo mas grande posible (con una imprecision provocada):
														var incremento : Number = 100000;
														var imprecision : Number = 10; //Imprecision para que no actualice los numeros demasiado rapido.
														while (valorTemporal + incremento + (incremento * imprecision) > valorPosterior)
														{
															incremento /= 10;
															//Evita la imprecision al llegar a un limite (si no se, haria infinito):
															if (incremento <= 1) { imprecision = 0; }
															//trace("incremento "+incremento+" demasiado grande para " + valorPosterior + " (valor actual: "+valorTemporal+")");
														}
														//Incrementa el valor actual de la animacion:
														valorTemporal += incremento;
													}
													else if (valorTemporal > valorPosterior)
													{
														//Elige el decremento lo mas grande posible (con una imprecision provocada):
														var decremento : Number = 100000;
														var imprecision : Number = 10; //Imprecision para que no actualice los numeros demasiado rapido.
														//while (valorTemporal - decremento - (decremento / imprecision) < valorPosterior)
														while (valorTemporal - decremento - (decremento * imprecision) < valorPosterior)
														{
															//trace("dekremento "+decremento+" demasiado grande para " + valorPosterior + " (valor actual: "+valorTemporal+")");
															decremento /= 10;
															//Evita la imprecision al llegar a un limite (si no, se haria infinito):
															//if (decremento <= 1) { imprecision = -0.5; } //Para que de el doble en la resta del while, y asi sea como solo restar uno (como valorTemporal - decremento, sin restarle la division de la imprecision).
															if (decremento <= 1) { imprecision = 0; }
														}
														//Decrementa el valor actual de la animacion:
														valorTemporal -= decremento;
													}
												   
													//Pone la posicion y el valor elegidos:
													clipRegistro.numero.text = posicionTemporal;
													clipRegistro.valor.text = valorTemporal;
													
													if (posicionTemporal == posicionPosterior && valorTemporal == valorPosterior)
													{
													   clearInterval(Ranking.intervalActualizar[idRegistro]);
													   Ranking.enAnimacion[idRegistro + ""] = false;
													   //trace("se akaba la animacion de aktualizar de " + idRegistro + " (en posicion "+posicionAnterior+")");
													}
												 }
												 , Ranking.milisegundosCicloActualizar, idRegistro, clipRegistro, posicionAnterior, posicionPosterior, valorAnterior, valorPosterior);

	}

	
	//Pone la flecha enviada a un registro del ranking:
	static function ponerFlecha(registro : Registro, tipoFlecha : String): Void
	{
		//Si la duracion de la flecha es cero (nunca visible), sale sin ponerla:
		if (Ranking.milisegundosDuracionFlecha == 0) { return; }
		
		var tipo : Object = { baja : 0, igual : 1, sube : 2, nada : 3 };
		
		//Pone el tipo de flecha enviado:
		registro.setAccion(tipo[tipoFlecha]);

		var clipRegistro : MovieClip = Ranking.getClipRegistro(registro.getID());
		
		//trace("PONE FLECHA " + tipoFlecha + " a " + registro.getID());
		
		//Si aun no existe, lo carga:
		if (clipRegistro == null)
		{
			clipRegistro = movieClip.attachMovie("ClipRegistro", "clipRegistro_" + registro.getID(), movieClip.getNextHighestDepth());
			Ranking.setClipRegistro(clipRegistro, registro.getID());
		}
		
		//Va al fotograma conveniente del clip del registro, segun su accion:
		clipRegistro.gotoAndStop(registro.getAccion() + 1);

		//Si la duracion de la flecha es -1 (siempre visible), sale sin quitarla:
		if (Ranking.milisegundosDuracionFlecha == -1) { return; }

		//Dentro de un rato, quita la flecha:
		var idRegistro : Number = registro.getID();
		clearInterval(Ranking.intervalFlechaDesaparecer[idRegistro]);
		Ranking.enAnimacion[idRegistro + ""] = true;
		Ranking.intervalFlechaDesaparecer[idRegistro] = setInterval(
 											     function()
											     {
													 //Quita la flecha y destruye este interval:
												     registro.setAccion(tipo["nada"]);
													 clipRegistro.gotoAndStop(registro.getAccion() + 1);
													 		//trace("QUITA FLECHA a " + registro.getID());
  													 Ranking.enAnimacion[idRegistro + ""] = false;
												     clearInterval(Ranking.intervalFlechaDesaparecer[idRegistro]);
											     }
											     , milisegundosDuracionFlecha, registro, tipo, clipRegistro);
	}
	
	
	//Representa visualmente todo el ranking:
	static function representarRanking() : Void
	{
		var movieClip : MovieClip = Ranking.getMovieClip();
		if (movieClip == null) { return; }
		
		var margenRegistro : Number = Ranking.getMargenRegistro();
		
		//Recorre todos los registros:
		var clipRegistro : MovieClip = null;
		var left : Number = Ranking.getRankingLeft();
		var top : Number = Ranking.getRankingTop();
		var registro : Registro = null;
		for (var x = 0; x < Ranking.getNumeroRegistros(); x++)
		{
			registro = Ranking.getRegistro(x);
			clipRegistro = Ranking.getClipRegistro(registro.getID());

			//Si aun no existe, lo carga:
			if (clipRegistro == null)
			{
				clipRegistro = movieClip.attachMovie("ClipRegistro", "clipRegistro_" + registro.getID(), movieClip.getNextHighestDepth());
				Ranking.setClipRegistro(clipRegistro, registro.getID());
			}
			
			//Define el texto del clip del registro:
			clipRegistro.texto.text = registro.getNombre();
			clipRegistro.numero.text = x + 1;
			clipRegistro.valor.text = registro.getValor();

			//Va al fotograma conveniente del clip del registro, segun su accion:
			clipRegistro.gotoAndStop(registro.getAccion() + 1);
			
			//Posiciona correctamente el clip del registro:
			clipRegistro._x = left;
			clipRegistro._y = top;
			
			top += Ranking.getEspacioEntreRegistros() + margenRegistro;
			
			//Modifica la dimension del clip del registro:
			//clipRegistro._width = (Ranking.registros[x].toString().length * clipRegistro.texto.size * 2) + margenRegistro;
			clipRegistro._width = Ranking.getAnchoRegistro();
			clipRegistro._height = Ranking.getAltoRegistro();
			
			//Se restaura el alpha, por si acaso:
			//clipRegistro._alpha = 100;
			//clipRegistro.texto._alpha = 0;
		}
		
		//Redimensiona el MovieClip principal:
		//movieClip._width = left + anchoMaximoClipRegistro + margenVentana;
		//movieClip.height = top + margenVentana;
	}
}